<?xml version="1.0"?>
<api version="1.0">
	<namespace name="Ctpl">
		<function name="eval_bool" symbol="ctpl_eval_bool">
			<return-type type="gboolean"/>
			<parameters>
				<parameter name="expr" type="CtplTokenExpr*"/>
				<parameter name="env" type="CtplEnviron*"/>
				<parameter name="result" type="gboolean*"/>
				<parameter name="error" type="GError**"/>
			</parameters>
		</function>
		<function name="eval_error_quark" symbol="ctpl_eval_error_quark">
			<return-type type="GQuark"/>
		</function>
		<function name="eval_value" symbol="ctpl_eval_value">
			<return-type type="gboolean"/>
			<parameters>
				<parameter name="expr" type="CtplTokenExpr*"/>
				<parameter name="env" type="CtplEnviron*"/>
				<parameter name="value" type="CtplValue*"/>
				<parameter name="error" type="GError**"/>
			</parameters>
		</function>
		<function name="io_error_quark" symbol="ctpl_io_error_quark">
			<return-type type="GQuark"/>
		</function>
		<function name="lexer_dump_tree" symbol="ctpl_lexer_dump_tree">
			<return-type type="void"/>
			<parameters>
				<parameter name="root" type="CtplToken*"/>
			</parameters>
		</function>
		<function name="lexer_error_quark" symbol="ctpl_lexer_error_quark">
			<return-type type="GQuark"/>
		</function>
		<function name="lexer_expr_error_quark" symbol="ctpl_lexer_expr_error_quark">
			<return-type type="GQuark"/>
		</function>
		<function name="lexer_expr_lex" symbol="ctpl_lexer_expr_lex">
			<return-type type="CtplTokenExpr*"/>
			<parameters>
				<parameter name="stream" type="CtplInputStream*"/>
				<parameter name="error" type="GError**"/>
			</parameters>
		</function>
		<function name="lexer_expr_lex_full" symbol="ctpl_lexer_expr_lex_full">
			<return-type type="CtplTokenExpr*"/>
			<parameters>
				<parameter name="stream" type="CtplInputStream*"/>
				<parameter name="lex_all" type="gboolean"/>
				<parameter name="error" type="GError**"/>
			</parameters>
		</function>
		<function name="lexer_expr_lex_string" symbol="ctpl_lexer_expr_lex_string">
			<return-type type="CtplTokenExpr*"/>
			<parameters>
				<parameter name="expr" type="gchar*"/>
				<parameter name="len" type="gssize"/>
				<parameter name="error" type="GError**"/>
			</parameters>
		</function>
		<function name="lexer_free_tree" symbol="ctpl_lexer_free_tree">
			<return-type type="void"/>
			<parameters>
				<parameter name="root" type="CtplToken*"/>
			</parameters>
		</function>
		<function name="lexer_lex" symbol="ctpl_lexer_lex">
			<return-type type="CtplToken*"/>
			<parameters>
				<parameter name="stream" type="CtplInputStream*"/>
				<parameter name="error" type="GError**"/>
			</parameters>
		</function>
		<function name="lexer_lex_path" symbol="ctpl_lexer_lex_path">
			<return-type type="CtplToken*"/>
			<parameters>
				<parameter name="path" type="gchar*"/>
				<parameter name="error" type="GError**"/>
			</parameters>
		</function>
		<function name="lexer_lex_string" symbol="ctpl_lexer_lex_string">
			<return-type type="CtplToken*"/>
			<parameters>
				<parameter name="template" type="gchar*"/>
				<parameter name="error" type="GError**"/>
			</parameters>
		</function>
		<function name="operator_from_string" symbol="ctpl_operator_from_string">
			<return-type type="CtplOperator"/>
			<parameters>
				<parameter name="str" type="gchar*"/>
				<parameter name="len" type="gssize"/>
				<parameter name="operator_len" type="gsize*"/>
			</parameters>
		</function>
		<function name="operator_to_string" symbol="ctpl_operator_to_string">
			<return-type type="gchar*"/>
			<parameters>
				<parameter name="op" type="CtplOperator"/>
			</parameters>
		</function>
		<function name="parser_error_quark" symbol="ctpl_parser_error_quark">
			<return-type type="GQuark"/>
		</function>
		<function name="parser_parse" symbol="ctpl_parser_parse">
			<return-type type="gboolean"/>
			<parameters>
				<parameter name="tree" type="CtplToken*"/>
				<parameter name="env" type="CtplEnviron*"/>
				<parameter name="output" type="CtplOutputStream*"/>
				<parameter name="error" type="GError**"/>
			</parameters>
		</function>
		<callback name="CtplEnvironForeachFunc">
			<return-type type="gboolean"/>
			<parameters>
				<parameter name="env" type="CtplEnviron*"/>
				<parameter name="symbol" type="gchar*"/>
				<parameter name="value" type="CtplValue*"/>
				<parameter name="user_data" type="gpointer"/>
			</parameters>
		</callback>
		<struct name="CtplEnviron">
			<method name="add_from_path" symbol="ctpl_environ_add_from_path">
				<return-type type="gboolean"/>
				<parameters>
					<parameter name="env" type="CtplEnviron*"/>
					<parameter name="path" type="gchar*"/>
					<parameter name="error" type="GError**"/>
				</parameters>
			</method>
			<method name="add_from_stream" symbol="ctpl_environ_add_from_stream">
				<return-type type="gboolean"/>
				<parameters>
					<parameter name="env" type="CtplEnviron*"/>
					<parameter name="stream" type="CtplInputStream*"/>
					<parameter name="error" type="GError**"/>
				</parameters>
			</method>
			<method name="add_from_string" symbol="ctpl_environ_add_from_string">
				<return-type type="gboolean"/>
				<parameters>
					<parameter name="env" type="CtplEnviron*"/>
					<parameter name="string" type="gchar*"/>
					<parameter name="error" type="GError**"/>
				</parameters>
			</method>
			<method name="error_quark" symbol="ctpl_environ_error_quark">
				<return-type type="GQuark"/>
			</method>
			<method name="foreach" symbol="ctpl_environ_foreach">
				<return-type type="void"/>
				<parameters>
					<parameter name="env" type="CtplEnviron*"/>
					<parameter name="func" type="CtplEnvironForeachFunc"/>
					<parameter name="user_data" type="gpointer"/>
				</parameters>
			</method>
			<method name="free" symbol="ctpl_environ_free">
				<return-type type="void"/>
				<parameters>
					<parameter name="env" type="CtplEnviron*"/>
				</parameters>
			</method>
			<method name="lookup" symbol="ctpl_environ_lookup">
				<return-type type="CtplValue*"/>
				<parameters>
					<parameter name="env" type="CtplEnviron*"/>
					<parameter name="symbol" type="gchar*"/>
				</parameters>
			</method>
			<method name="merge" symbol="ctpl_environ_merge">
				<return-type type="void"/>
				<parameters>
					<parameter name="env" type="CtplEnviron*"/>
					<parameter name="source" type="CtplEnviron*"/>
					<parameter name="merge_symbols" type="gboolean"/>
				</parameters>
			</method>
			<method name="new" symbol="ctpl_environ_new">
				<return-type type="CtplEnviron*"/>
			</method>
			<method name="pop" symbol="ctpl_environ_pop">
				<return-type type="CtplValue*"/>
				<parameters>
					<parameter name="env" type="CtplEnviron*"/>
					<parameter name="symbol" type="gchar*"/>
				</parameters>
			</method>
			<method name="push" symbol="ctpl_environ_push">
				<return-type type="void"/>
				<parameters>
					<parameter name="env" type="CtplEnviron*"/>
					<parameter name="symbol" type="gchar*"/>
					<parameter name="value" type="CtplValue*"/>
				</parameters>
			</method>
			<method name="push_float" symbol="ctpl_environ_push_float">
				<return-type type="void"/>
				<parameters>
					<parameter name="env" type="CtplEnviron*"/>
					<parameter name="symbol" type="gchar*"/>
					<parameter name="value" type="gdouble"/>
				</parameters>
			</method>
			<method name="push_int" symbol="ctpl_environ_push_int">
				<return-type type="void"/>
				<parameters>
					<parameter name="env" type="CtplEnviron*"/>
					<parameter name="symbol" type="gchar*"/>
					<parameter name="value" type="glong"/>
				</parameters>
			</method>
			<method name="push_string" symbol="ctpl_environ_push_string">
				<return-type type="void"/>
				<parameters>
					<parameter name="env" type="CtplEnviron*"/>
					<parameter name="symbol" type="gchar*"/>
					<parameter name="value" type="gchar*"/>
				</parameters>
			</method>
			<field name="symbol_table" type="GHashTable*"/>
		</struct>
		<struct name="CtplInputStream">
			<method name="eof" symbol="ctpl_input_stream_eof">
				<return-type type="gboolean"/>
				<parameters>
					<parameter name="stream" type="CtplInputStream*"/>
					<parameter name="error" type="GError**"/>
				</parameters>
			</method>
			<method name="eof_fast" symbol="ctpl_input_stream_eof_fast">
				<return-type type="gboolean"/>
				<parameters>
					<parameter name="stream" type="CtplInputStream*"/>
				</parameters>
			</method>
			<method name="get_c" symbol="ctpl_input_stream_get_c">
				<return-type type="gchar"/>
				<parameters>
					<parameter name="stream" type="CtplInputStream*"/>
					<parameter name="error" type="GError**"/>
				</parameters>
			</method>
			<method name="new" symbol="ctpl_input_stream_new">
				<return-type type="CtplInputStream*"/>
				<parameters>
					<parameter name="stream" type="GInputStream*"/>
					<parameter name="name" type="gchar*"/>
				</parameters>
			</method>
			<method name="new_for_gfile" symbol="ctpl_input_stream_new_for_gfile">
				<return-type type="CtplInputStream*"/>
				<parameters>
					<parameter name="file" type="GFile*"/>
					<parameter name="error" type="GError**"/>
				</parameters>
			</method>
			<method name="new_for_memory" symbol="ctpl_input_stream_new_for_memory">
				<return-type type="CtplInputStream*"/>
				<parameters>
					<parameter name="data" type="gchar*"/>
					<parameter name="length" type="gssize"/>
					<parameter name="destroy" type="GDestroyNotify"/>
					<parameter name="name" type="gchar*"/>
				</parameters>
			</method>
			<method name="new_for_path" symbol="ctpl_input_stream_new_for_path">
				<return-type type="CtplInputStream*"/>
				<parameters>
					<parameter name="path" type="gchar*"/>
					<parameter name="error" type="GError**"/>
				</parameters>
			</method>
			<method name="new_for_uri" symbol="ctpl_input_stream_new_for_uri">
				<return-type type="CtplInputStream*"/>
				<parameters>
					<parameter name="uri" type="gchar*"/>
					<parameter name="error" type="GError**"/>
				</parameters>
			</method>
			<method name="peek" symbol="ctpl_input_stream_peek">
				<return-type type="gssize"/>
				<parameters>
					<parameter name="stream" type="CtplInputStream*"/>
					<parameter name="buffer" type="void*"/>
					<parameter name="count" type="gsize"/>
					<parameter name="error" type="GError**"/>
				</parameters>
			</method>
			<method name="peek_c" symbol="ctpl_input_stream_peek_c">
				<return-type type="gchar"/>
				<parameters>
					<parameter name="stream" type="CtplInputStream*"/>
					<parameter name="error" type="GError**"/>
				</parameters>
			</method>
			<method name="peek_symbol_full" symbol="ctpl_input_stream_peek_symbol_full">
				<return-type type="gchar*"/>
				<parameters>
					<parameter name="stream" type="CtplInputStream*"/>
					<parameter name="max_len" type="gssize"/>
					<parameter name="length" type="gsize*"/>
					<parameter name="error" type="GError**"/>
				</parameters>
			</method>
			<method name="peek_word" symbol="ctpl_input_stream_peek_word">
				<return-type type="gchar*"/>
				<parameters>
					<parameter name="stream" type="CtplInputStream*"/>
					<parameter name="accept" type="gchar*"/>
					<parameter name="accept_len" type="gssize"/>
					<parameter name="max_len" type="gssize"/>
					<parameter name="length" type="gsize*"/>
					<parameter name="error" type="GError**"/>
				</parameters>
			</method>
			<method name="read" symbol="ctpl_input_stream_read">
				<return-type type="gssize"/>
				<parameters>
					<parameter name="stream" type="CtplInputStream*"/>
					<parameter name="buffer" type="void*"/>
					<parameter name="count" type="gsize"/>
					<parameter name="error" type="GError**"/>
				</parameters>
			</method>
			<method name="read_double" symbol="ctpl_input_stream_read_double">
				<return-type type="gdouble"/>
				<parameters>
					<parameter name="stream" type="CtplInputStream*"/>
					<parameter name="error" type="GError**"/>
				</parameters>
			</method>
			<method name="read_long" symbol="ctpl_input_stream_read_long">
				<return-type type="glong"/>
				<parameters>
					<parameter name="stream" type="CtplInputStream*"/>
					<parameter name="error" type="GError**"/>
				</parameters>
			</method>
			<method name="read_number" symbol="ctpl_input_stream_read_number">
				<return-type type="gboolean"/>
				<parameters>
					<parameter name="stream" type="CtplInputStream*"/>
					<parameter name="value" type="CtplValue*"/>
					<parameter name="error" type="GError**"/>
				</parameters>
			</method>
			<method name="read_string_literal" symbol="ctpl_input_stream_read_string_literal">
				<return-type type="gchar*"/>
				<parameters>
					<parameter name="stream" type="CtplInputStream*"/>
					<parameter name="error" type="GError**"/>
				</parameters>
			</method>
			<method name="read_symbol_full" symbol="ctpl_input_stream_read_symbol_full">
				<return-type type="gchar*"/>
				<parameters>
					<parameter name="stream" type="CtplInputStream*"/>
					<parameter name="max_len" type="gssize"/>
					<parameter name="length" type="gsize*"/>
					<parameter name="error" type="GError**"/>
				</parameters>
			</method>
			<method name="read_word" symbol="ctpl_input_stream_read_word">
				<return-type type="gchar*"/>
				<parameters>
					<parameter name="stream" type="CtplInputStream*"/>
					<parameter name="accept" type="gchar*"/>
					<parameter name="accept_len" type="gssize"/>
					<parameter name="max_len" type="gssize"/>
					<parameter name="length" type="gsize*"/>
					<parameter name="error" type="GError**"/>
				</parameters>
			</method>
			<method name="ref" symbol="ctpl_input_stream_ref">
				<return-type type="CtplInputStream*"/>
				<parameters>
					<parameter name="stream" type="CtplInputStream*"/>
				</parameters>
			</method>
			<method name="set_error" symbol="ctpl_input_stream_set_error">
				<return-type type="void"/>
				<parameters>
					<parameter name="stream" type="CtplInputStream*"/>
					<parameter name="error" type="GError**"/>
					<parameter name="domain" type="GQuark"/>
					<parameter name="code" type="gint"/>
					<parameter name="format" type="gchar*"/>
				</parameters>
			</method>
			<method name="skip" symbol="ctpl_input_stream_skip">
				<return-type type="gssize"/>
				<parameters>
					<parameter name="stream" type="CtplInputStream*"/>
					<parameter name="count" type="gsize"/>
					<parameter name="error" type="GError**"/>
				</parameters>
			</method>
			<method name="skip_blank" symbol="ctpl_input_stream_skip_blank">
				<return-type type="gssize"/>
				<parameters>
					<parameter name="stream" type="CtplInputStream*"/>
					<parameter name="error" type="GError**"/>
				</parameters>
			</method>
			<method name="skip_word" symbol="ctpl_input_stream_skip_word">
				<return-type type="gssize"/>
				<parameters>
					<parameter name="stream" type="CtplInputStream*"/>
					<parameter name="reject" type="gchar*"/>
					<parameter name="reject_len" type="gssize"/>
					<parameter name="error" type="GError**"/>
				</parameters>
			</method>
			<method name="unref" symbol="ctpl_input_stream_unref">
				<return-type type="void"/>
				<parameters>
					<parameter name="stream" type="CtplInputStream*"/>
				</parameters>
			</method>
			<field name="ref_count" type="gint"/>
			<field name="stream" type="GInputStream*"/>
			<field name="buffer" type="gchar*"/>
			<field name="buf_size" type="gsize"/>
			<field name="buf_pos" type="gsize"/>
			<field name="name" type="gchar*"/>
			<field name="line" type="guint"/>
			<field name="pos" type="guint"/>
		</struct>
		<struct name="CtplOutputStream">
			<method name="put_c" symbol="ctpl_output_stream_put_c">
				<return-type type="gboolean"/>
				<parameters>
					<parameter name="stream" type="CtplOutputStream*"/>
					<parameter name="c" type="gchar"/>
					<parameter name="error" type="GError**"/>
				</parameters>
			</method>
			<method name="write" symbol="ctpl_output_stream_write">
				<return-type type="gboolean"/>
				<parameters>
					<parameter name="stream" type="CtplOutputStream*"/>
					<parameter name="data" type="gchar*"/>
					<parameter name="length" type="gssize"/>
					<parameter name="error" type="GError**"/>
				</parameters>
			</method>
		</struct>
		<struct name="CtplToken">
			<method name="append" symbol="ctpl_token_append">
				<return-type type="void"/>
				<parameters>
					<parameter name="token" type="CtplToken*"/>
					<parameter name="brother" type="CtplToken*"/>
				</parameters>
			</method>
			<method name="dump" symbol="ctpl_token_dump">
				<return-type type="void"/>
				<parameters>
					<parameter name="token" type="CtplToken*"/>
					<parameter name="chain" type="gboolean"/>
				</parameters>
			</method>
			<method name="free" symbol="ctpl_token_free">
				<return-type type="void"/>
				<parameters>
					<parameter name="token" type="CtplToken*"/>
					<parameter name="chain" type="gboolean"/>
				</parameters>
			</method>
			<method name="new_data" symbol="ctpl_token_new_data">
				<return-type type="CtplToken*"/>
				<parameters>
					<parameter name="data" type="gchar*"/>
					<parameter name="len" type="gssize"/>
				</parameters>
			</method>
			<method name="new_expr" symbol="ctpl_token_new_expr">
				<return-type type="CtplToken*"/>
				<parameters>
					<parameter name="expr" type="CtplTokenExpr*"/>
				</parameters>
			</method>
			<method name="new_for" symbol="ctpl_token_new_for">
				<return-type type="CtplToken*"/>
				<parameters>
					<parameter name="array" type="gchar*"/>
					<parameter name="iterator" type="gchar*"/>
					<parameter name="children" type="CtplToken*"/>
				</parameters>
			</method>
			<method name="new_if" symbol="ctpl_token_new_if">
				<return-type type="CtplToken*"/>
				<parameters>
					<parameter name="condition" type="CtplTokenExpr*"/>
					<parameter name="if_children" type="CtplToken*"/>
					<parameter name="else_children" type="CtplToken*"/>
				</parameters>
			</method>
			<method name="prepend" symbol="ctpl_token_prepend">
				<return-type type="void"/>
				<parameters>
					<parameter name="token" type="CtplToken*"/>
					<parameter name="brother" type="CtplToken*"/>
				</parameters>
			</method>
			<field name="type" type="CtplTokenType"/>
			<field name="token" type="CtplTokenValue"/>
			<field name="next" type="CtplToken*"/>
			<field name="last" type="CtplToken*"/>
		</struct>
		<struct name="CtplTokenExpr">
			<method name="dump" symbol="ctpl_token_expr_dump">
				<return-type type="void"/>
				<parameters>
					<parameter name="token" type="CtplTokenExpr*"/>
				</parameters>
			</method>
			<method name="free" symbol="ctpl_token_expr_free">
				<return-type type="void"/>
				<parameters>
					<parameter name="token" type="CtplTokenExpr*"/>
					<parameter name="recurse" type="gboolean"/>
				</parameters>
			</method>
			<method name="new_float" symbol="ctpl_token_expr_new_float">
				<return-type type="CtplTokenExpr*"/>
				<parameters>
					<parameter name="real" type="gdouble"/>
				</parameters>
			</method>
			<method name="new_integer" symbol="ctpl_token_expr_new_integer">
				<return-type type="CtplTokenExpr*"/>
				<parameters>
					<parameter name="integer" type="glong"/>
				</parameters>
			</method>
			<method name="new_operator" symbol="ctpl_token_expr_new_operator">
				<return-type type="CtplTokenExpr*"/>
				<parameters>
					<parameter name="operator" type="CtplOperator"/>
					<parameter name="loperand" type="CtplTokenExpr*"/>
					<parameter name="roperand" type="CtplTokenExpr*"/>
				</parameters>
			</method>
			<method name="new_symbol" symbol="ctpl_token_expr_new_symbol">
				<return-type type="CtplTokenExpr*"/>
				<parameters>
					<parameter name="symbol" type="gchar*"/>
					<parameter name="len" type="gssize"/>
				</parameters>
			</method>
			<field name="type" type="CtplTokenExprType"/>
			<field name="token" type="CtplTokenExprValue"/>
		</struct>
		<struct name="CtplTokenExprOperator">
			<field name="operator" type="CtplOperator"/>
			<field name="loperand" type="CtplTokenExpr*"/>
			<field name="roperand" type="CtplTokenExpr*"/>
		</struct>
		<struct name="CtplTokenFor">
			<field name="array" type="gchar*"/>
			<field name="iter" type="gchar*"/>
			<field name="children" type="CtplToken*"/>
		</struct>
		<struct name="CtplTokenIf">
			<field name="condition" type="CtplTokenExpr*"/>
			<field name="if_children" type="CtplToken*"/>
			<field name="else_children" type="CtplToken*"/>
		</struct>
		<struct name="CtplValue">
			<method name="array_append" symbol="ctpl_value_array_append">
				<return-type type="void"/>
				<parameters>
					<parameter name="value" type="CtplValue*"/>
					<parameter name="val" type="CtplValue*"/>
				</parameters>
			</method>
			<method name="array_append_float" symbol="ctpl_value_array_append_float">
				<return-type type="void"/>
				<parameters>
					<parameter name="value" type="CtplValue*"/>
					<parameter name="val" type="gdouble"/>
				</parameters>
			</method>
			<method name="array_append_int" symbol="ctpl_value_array_append_int">
				<return-type type="void"/>
				<parameters>
					<parameter name="value" type="CtplValue*"/>
					<parameter name="val" type="glong"/>
				</parameters>
			</method>
			<method name="array_append_string" symbol="ctpl_value_array_append_string">
				<return-type type="void"/>
				<parameters>
					<parameter name="value" type="CtplValue*"/>
					<parameter name="val" type="gchar*"/>
				</parameters>
			</method>
			<method name="array_length" symbol="ctpl_value_array_length">
				<return-type type="gsize"/>
				<parameters>
					<parameter name="value" type="CtplValue*"/>
				</parameters>
			</method>
			<method name="array_prepend" symbol="ctpl_value_array_prepend">
				<return-type type="void"/>
				<parameters>
					<parameter name="value" type="CtplValue*"/>
					<parameter name="val" type="CtplValue*"/>
				</parameters>
			</method>
			<method name="array_prepend_float" symbol="ctpl_value_array_prepend_float">
				<return-type type="void"/>
				<parameters>
					<parameter name="value" type="CtplValue*"/>
					<parameter name="val" type="gdouble"/>
				</parameters>
			</method>
			<method name="array_prepend_int" symbol="ctpl_value_array_prepend_int">
				<return-type type="void"/>
				<parameters>
					<parameter name="value" type="CtplValue*"/>
					<parameter name="val" type="glong"/>
				</parameters>
			</method>
			<method name="array_prepend_string" symbol="ctpl_value_array_prepend_string">
				<return-type type="void"/>
				<parameters>
					<parameter name="value" type="CtplValue*"/>
					<parameter name="val" type="gchar*"/>
				</parameters>
			</method>
			<method name="convert" symbol="ctpl_value_convert">
				<return-type type="gboolean"/>
				<parameters>
					<parameter name="value" type="CtplValue*"/>
					<parameter name="vtype" type="CtplValueType"/>
				</parameters>
			</method>
			<method name="copy" symbol="ctpl_value_copy">
				<return-type type="void"/>
				<parameters>
					<parameter name="src_value" type="CtplValue*"/>
					<parameter name="dst_value" type="CtplValue*"/>
				</parameters>
			</method>
			<method name="dup" symbol="ctpl_value_dup">
				<return-type type="CtplValue*"/>
				<parameters>
					<parameter name="value" type="CtplValue*"/>
				</parameters>
			</method>
			<method name="free" symbol="ctpl_value_free">
				<return-type type="void"/>
				<parameters>
					<parameter name="value" type="CtplValue*"/>
				</parameters>
			</method>
			<method name="free_value" symbol="ctpl_value_free_value">
				<return-type type="void"/>
				<parameters>
					<parameter name="value" type="CtplValue*"/>
				</parameters>
			</method>
			<method name="get_array" symbol="ctpl_value_get_array">
				<return-type type="GSList*"/>
				<parameters>
					<parameter name="value" type="CtplValue*"/>
				</parameters>
			</method>
			<method name="get_array_float" symbol="ctpl_value_get_array_float">
				<return-type type="gdouble*"/>
				<parameters>
					<parameter name="value" type="CtplValue*"/>
					<parameter name="length" type="gsize*"/>
				</parameters>
			</method>
			<method name="get_array_int" symbol="ctpl_value_get_array_int">
				<return-type type="glong*"/>
				<parameters>
					<parameter name="value" type="CtplValue*"/>
					<parameter name="length" type="gsize*"/>
				</parameters>
			</method>
			<method name="get_array_string" symbol="ctpl_value_get_array_string">
				<return-type type="gchar**"/>
				<parameters>
					<parameter name="value" type="CtplValue*"/>
					<parameter name="length" type="gsize*"/>
				</parameters>
			</method>
			<method name="get_float" symbol="ctpl_value_get_float">
				<return-type type="gdouble"/>
				<parameters>
					<parameter name="value" type="CtplValue*"/>
				</parameters>
			</method>
			<method name="get_held_type" symbol="ctpl_value_get_held_type">
				<return-type type="CtplValueType"/>
				<parameters>
					<parameter name="value" type="CtplValue*"/>
				</parameters>
			</method>
			<method name="get_int" symbol="ctpl_value_get_int">
				<return-type type="glong"/>
				<parameters>
					<parameter name="value" type="CtplValue*"/>
				</parameters>
			</method>
			<method name="get_string" symbol="ctpl_value_get_string">
				<return-type type="gchar*"/>
				<parameters>
					<parameter name="value" type="CtplValue*"/>
				</parameters>
			</method>
			<method name="init" symbol="ctpl_value_init">
				<return-type type="void"/>
				<parameters>
					<parameter name="value" type="CtplValue*"/>
				</parameters>
			</method>
			<method name="new" symbol="ctpl_value_new">
				<return-type type="CtplValue*"/>
			</method>
			<method name="new_array" symbol="ctpl_value_new_array">
				<return-type type="CtplValue*"/>
				<parameters>
					<parameter name="type" type="CtplValueType"/>
					<parameter name="count" type="gsize"/>
				</parameters>
			</method>
			<method name="new_arrayv" symbol="ctpl_value_new_arrayv">
				<return-type type="CtplValue*"/>
				<parameters>
					<parameter name="type" type="CtplValueType"/>
					<parameter name="count" type="gsize"/>
					<parameter name="ap" type="va_list"/>
				</parameters>
			</method>
			<method name="new_float" symbol="ctpl_value_new_float">
				<return-type type="CtplValue*"/>
				<parameters>
					<parameter name="val" type="gdouble"/>
				</parameters>
			</method>
			<method name="new_int" symbol="ctpl_value_new_int">
				<return-type type="CtplValue*"/>
				<parameters>
					<parameter name="val" type="glong"/>
				</parameters>
			</method>
			<method name="new_string" symbol="ctpl_value_new_string">
				<return-type type="CtplValue*"/>
				<parameters>
					<parameter name="val" type="gchar*"/>
				</parameters>
			</method>
			<method name="set_array" symbol="ctpl_value_set_array">
				<return-type type="void"/>
				<parameters>
					<parameter name="value" type="CtplValue*"/>
					<parameter name="type" type="CtplValueType"/>
					<parameter name="count" type="gsize"/>
				</parameters>
			</method>
			<method name="set_array_float" symbol="ctpl_value_set_array_float">
				<return-type type="void"/>
				<parameters>
					<parameter name="value" type="CtplValue*"/>
					<parameter name="count" type="gsize"/>
				</parameters>
			</method>
			<method name="set_array_floatv" symbol="ctpl_value_set_array_floatv">
				<return-type type="void"/>
				<parameters>
					<parameter name="value" type="CtplValue*"/>
					<parameter name="count" type="gsize"/>
					<parameter name="ap" type="va_list"/>
				</parameters>
			</method>
			<method name="set_array_int" symbol="ctpl_value_set_array_int">
				<return-type type="void"/>
				<parameters>
					<parameter name="value" type="CtplValue*"/>
					<parameter name="count" type="gsize"/>
				</parameters>
			</method>
			<method name="set_array_intv" symbol="ctpl_value_set_array_intv">
				<return-type type="void"/>
				<parameters>
					<parameter name="value" type="CtplValue*"/>
					<parameter name="count" type="gsize"/>
					<parameter name="ap" type="va_list"/>
				</parameters>
			</method>
			<method name="set_array_string" symbol="ctpl_value_set_array_string">
				<return-type type="void"/>
				<parameters>
					<parameter name="value" type="CtplValue*"/>
					<parameter name="count" type="gsize"/>
				</parameters>
			</method>
			<method name="set_array_stringv" symbol="ctpl_value_set_array_stringv">
				<return-type type="void"/>
				<parameters>
					<parameter name="value" type="CtplValue*"/>
					<parameter name="count" type="gsize"/>
					<parameter name="ap" type="va_list"/>
				</parameters>
			</method>
			<method name="set_arrayv" symbol="ctpl_value_set_arrayv">
				<return-type type="void"/>
				<parameters>
					<parameter name="value" type="CtplValue*"/>
					<parameter name="type" type="CtplValueType"/>
					<parameter name="count" type="gsize"/>
					<parameter name="ap" type="va_list"/>
				</parameters>
			</method>
			<method name="set_float" symbol="ctpl_value_set_float">
				<return-type type="void"/>
				<parameters>
					<parameter name="value" type="CtplValue*"/>
					<parameter name="val" type="gdouble"/>
				</parameters>
			</method>
			<method name="set_int" symbol="ctpl_value_set_int">
				<return-type type="void"/>
				<parameters>
					<parameter name="value" type="CtplValue*"/>
					<parameter name="val" type="glong"/>
				</parameters>
			</method>
			<method name="set_string" symbol="ctpl_value_set_string">
				<return-type type="void"/>
				<parameters>
					<parameter name="value" type="CtplValue*"/>
					<parameter name="val" type="gchar*"/>
				</parameters>
			</method>
			<method name="to_string" symbol="ctpl_value_to_string">
				<return-type type="gchar*"/>
				<parameters>
					<parameter name="value" type="CtplValue*"/>
				</parameters>
			</method>
			<method name="type_get_name" symbol="ctpl_value_type_get_name">
				<return-type type="gchar*"/>
				<parameters>
					<parameter name="type" type="CtplValueType"/>
				</parameters>
			</method>
			<field name="type" type="gint"/>
			<field name="value" type="gpointer"/>
		</struct>
		<enum name="CtplEnvironError">
			<member name="CTPL_ENVIRON_ERROR_LOADER_MISSING_SYMBOL" value="0"/>
			<member name="CTPL_ENVIRON_ERROR_LOADER_MISSING_VALUE" value="1"/>
			<member name="CTPL_ENVIRON_ERROR_LOADER_MISSING_SEPARATOR" value="2"/>
			<member name="CTPL_ENVIRON_ERROR_FAILED" value="3"/>
		</enum>
		<enum name="CtplEvalError">
			<member name="CTPL_EVAL_ERROR_INVALID_OPERAND" value="0"/>
			<member name="CTPL_EVAL_ERROR_SYMBOL_NOT_FOUND" value="1"/>
			<member name="CTPL_EVAL_ERROR_FAILED" value="2"/>
		</enum>
		<enum name="CtplIOError">
			<member name="CTPL_IO_ERROR_EOF" value="0"/>
			<member name="CTPL_IO_ERROR_INVALID_NUMBER" value="1"/>
			<member name="CTPL_IO_ERROR_INVALID_STRING" value="2"/>
			<member name="CTPL_IO_ERROR_RANGE" value="3"/>
			<member name="CTPL_IO_ERROR_NOMEM" value="4"/>
			<member name="CTPL_IO_ERROR_FAILED" value="5"/>
		</enum>
		<enum name="CtplLexerError">
			<member name="CTPL_LEXER_ERROR_SYNTAX_ERROR" value="0"/>
			<member name="CTPL_LEXER_ERROR_FAILED" value="1"/>
		</enum>
		<enum name="CtplLexerExprError">
			<member name="CTPL_LEXER_EXPR_ERROR_MISSING_OPERAND" value="0"/>
			<member name="CTPL_LEXER_EXPR_ERROR_MISSING_OPERATOR" value="1"/>
			<member name="CTPL_LEXER_EXPR_ERROR_SYNTAX_ERROR" value="2"/>
			<member name="CTPL_LEXER_EXPR_ERROR_FAILED" value="3"/>
		</enum>
		<enum name="CtplOperator">
			<member name="CTPL_OPERATOR_PLUS" value="0"/>
			<member name="CTPL_OPERATOR_MINUS" value="1"/>
			<member name="CTPL_OPERATOR_DIV" value="2"/>
			<member name="CTPL_OPERATOR_MUL" value="3"/>
			<member name="CTPL_OPERATOR_EQUAL" value="4"/>
			<member name="CTPL_OPERATOR_INF" value="5"/>
			<member name="CTPL_OPERATOR_SUP" value="6"/>
			<member name="CTPL_OPERATOR_MODULO" value="7"/>
			<member name="CTPL_OPERATOR_SUPEQ" value="8"/>
			<member name="CTPL_OPERATOR_INFEQ" value="9"/>
			<member name="CTPL_OPERATOR_NEQ" value="10"/>
			<member name="CTPL_OPERATOR_AND" value="11"/>
			<member name="CTPL_OPERATOR_OR" value="12"/>
			<member name="CTPL_OPERATOR_NONE" value="13"/>
		</enum>
		<enum name="CtplParserError">
			<member name="CTPL_PARSER_ERROR_INCOMPATIBLE_SYMBOL" value="0"/>
			<member name="CTPL_PARSER_ERROR_SYMBOL_NOT_FOUND" value="1"/>
			<member name="CTPL_PARSER_ERROR_FAILED" value="2"/>
		</enum>
		<enum name="CtplTokenExprType">
			<member name="CTPL_TOKEN_EXPR_TYPE_OPERATOR" value="0"/>
			<member name="CTPL_TOKEN_EXPR_TYPE_INTEGER" value="1"/>
			<member name="CTPL_TOKEN_EXPR_TYPE_FLOAT" value="2"/>
			<member name="CTPL_TOKEN_EXPR_TYPE_SYMBOL" value="3"/>
		</enum>
		<enum name="CtplTokenType">
			<member name="CTPL_TOKEN_TYPE_DATA" value="0"/>
			<member name="CTPL_TOKEN_TYPE_FOR" value="1"/>
			<member name="CTPL_TOKEN_TYPE_IF" value="2"/>
			<member name="CTPL_TOKEN_TYPE_EXPR" value="3"/>
		</enum>
		<enum name="CtplValueType">
			<member name="CTPL_VTYPE_INT" value="0"/>
			<member name="CTPL_VTYPE_FLOAT" value="1"/>
			<member name="CTPL_VTYPE_STRING" value="2"/>
			<member name="CTPL_VTYPE_ARRAY" value="3"/>
		</enum>
		<constant name="CTPL_BLANK_CHARS" type="char*" value=" 	v
"/>
		<constant name="CTPL_EOF" type="int" value="0"/>
		<constant name="CTPL_EXPR_CHARS" type="char*" value="()"/>
		<constant name="CTPL_OPERAND_CHARS" type="char*" value=".+-"/>
		<constant name="CTPL_OPERATOR_CHARS" type="char*" value="+-/*=&gt;&lt;%!&amp;|"/>
		<constant name="CTPL_SYMBOL_CHARS" type="char*" value="abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789_"/>
		<union name="CtplTokenExprValue">
			<field name="t_operator" type="CtplTokenExprOperator*"/>
			<field name="t_integer" type="glong"/>
			<field name="t_float" type="gdouble"/>
			<field name="t_symbol" type="gchar*"/>
		</union>
		<union name="CtplTokenValue">
			<field name="t_data" type="gchar*"/>
			<field name="t_expr" type="CtplTokenExpr*"/>
			<field name="t_for" type="CtplTokenFor*"/>
			<field name="t_if" type="CtplTokenIf*"/>
		</union>
	</namespace>
</api>
